unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, GLScene, GLMesh, GLObjects, GLCoordinates, GLCrossPlatform,
  BaseClasses, GLWin32Viewer, StdCtrls,math,
  VectorTypes, VectorGeometry, GLState;

type
  TForm1 = class(TForm)
    GLSceneViewer1: TGLSceneViewer;
    GLScene1: TGLScene;
    GLCamera1: TGLCamera;
    GLLightSource1: TGLLightSource;
    GLDummyCube1: TGLDummyCube;
    GLDummyCube2: TGLDummyCube;
    GLMesh1: TGLMesh;
    Button1: TButton;
    Button2: TButton;
    GLSphere1: TGLSphere;
    GLSphere2: TGLSphere;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure GLSceneViewer1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure GLSceneViewer1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
    { Private declarations }
    px,py   : integer;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
//  GLCamera1.Position.Z := 7;
end;

procedure TForm1.GLSceneViewer1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  px := X;
  py := Y;
end;

procedure TForm1.GLSceneViewer1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if ssLeft in Shift then begin
    GLCamera1.MoveAroundTarget(py-Y,px-X);
    px := X;
    py := Y;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  GLMesh1.Vertices.Clear;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  v0,v1,v2,nn  : TVector3f;
  cc           : TVector4f;
  x1,dd,Th,dT  : single;
  N,kk         : integer;
begin
  x1 := -3;
  dd := 0.5;
  N  := ceil(6/dd);
  Th := 0.0;
  dT := 2*Pi/N;
  SetVector(nn,0,0,0);

  setvector(cc,1,0,0,0.0);

  // primer triangulo
  SetVector(v0,   x1, 0,0);
  SetVector(v1,   x1,dd,0);
  SetVector(v2,x1+dd, 0,0);

  GLMesh1.Vertices.AddVertex(v0,nn,cc) ;
  GLMesh1.Vertices.AddVertex(v1,nn,cc) ;
  GLMesh1.Vertices.AddVertex(v2,nn,cc) ;

  for kk := 0 to N - 2 do begin
    Th := Th + dT;
    x1 := x1 + dd;
    SetVector(v0,   x1,dd*cos(Th),dd*sin(Th) );
    SetVector(v1,x1+dd, 0,0);

    GLMesh1.Vertices.AddVertex(v0,nn,cc) ;
    GLMesh1.Vertices.AddVertex(v1,nn,cc) ;
  end;

  x1 := x1 + dd;
  Th := Th + dT;
  SetVector(v0,   x1,dd*cos(Th),dd*sin(Th) );
  GLMesh1.Vertices.AddVertex(v0,nn,cc) ;

  GLMesh1.CalcNormals(fwClockWise);
end;


end.
